local keql, self = keql, keql

local L = LibStub("AceLocale-3.0"):GetLocale("keql")

local AWFW = 220
-- Addon functions

function keql:InitAchievementTracker()
	keql.AchievmentFrameTracker = CreateFrame("Frame","AchievmentFrameTracker", UIParent)
	keql.AchievmentFrameTracker:SetFrameStrata("BACKGROUND")
	keql.AchievmentFrameTracker:SetWidth(200)
	keql.AchievmentFrameTracker:SetHeight(100)
	keql.AchievmentFrameTracker:SetPoint("CENTER",0,0)
	keql.AchievmentFrameTracker:SetBackdrop({
--		bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
		insets = { left= 5, right = 5, top = 5, bottom = 5 }
		})			
	keql.AchievmentFrameTracker:Show()
	keql.AchievmentFrameTracker:RegisterForDrag("LeftButton");
	keql.AchievmentFrameTracker:SetMovable(true)
	keql.AchievmentFrameTracker:EnableMouse(true)
	keql.AchievmentFrameTracker:SetScript("OnDragStart",
        function() 
          keql.AchievmentFrameTracker.ismoving = true 
          keql.AchievmentFrameTracker:StartMoving() 
        end)
	keql.AchievmentFrameTracker:SetScript("OnDragStop",
        function() 
          keql.AchievmentFrameTracker.ismoving = false 
          keql.AchievmentFrameTracker:StopMovingOrSizing() 
          --keql:SavePositionTracker() 
        end)

	keql.AchievmentFrameTrackerTitle = CreateFrame("Frame","AchievmentFrameTrackerTitle", AchievmentFrameTracker)
	keql.AchievmentFrameTrackerTitle:ClearAllPoints()
	keql.AchievmentFrameTrackerTitle:SetHeight(32)
	keql.AchievmentFrameTrackerTitle:SetPoint("TOPLEFT",AchievmentFrameTracker, "TOPLEFT",0,0)
	keql.AchievmentFrameTrackerTitle:SetPoint("TOPRIGHT",AchievmentFrameTracker, "TOPRIGHT",0,0)
	keql.AchievmentFrameTrackerTitle:SetBackdrop({
--		bgFile="Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile = true, edgeSize = 16, tileSize = 16,
		insets = { left= 5, right = 5, top = 5, bottom = 5 }
		})			
	keql.AchievmentFrameTrackerTitle:SetFrameStrata("BACKGROUND")
	keql.AchievmentFrameTrackerTitle:SetFrameLevel("1")
	keql.AchievmentFrameTrackerTitle:SetAlpha(50)
	keql.AchievmentFrameTrackerTitle:SetMovable(true)
	keql.AchievmentFrameTrackerTitle:EnableMouse(true)
	keql.AchievmentFrameTrackerTitle:Show()

	
	keql.AchievmentFrameTrackerTitleText = keql.AchievmentFrameTrackerTitle:CreateFontString("AchievmentFrameTrackerTitleText","BACKGROUND","QuestWatchFontTemplate")
	keql.AchievmentFrameTrackerTitleText:SetPoint("LEFT",10,1)
	keql.AchievmentFrameTrackerTitleText:SetAlpha(1)
	keql.AchievmentFrameTrackerTitleText:SetText("Achievementtracker")


	keql.AchievmentFrameTrackerMinimizeButton = CreateFrame("Button","TrackerMinimizeButton", AchievmentFrameTrackerTitle, "UIPanelButtonTemplate")
	keql.AchievmentFrameTrackerMinimizeButton:SetNormalTexture("Interface\\AddOns\\keql\\Images\\minimize_up")
	keql.AchievmentFrameTrackerMinimizeButton:SetPushedTexture("Interface\\AddOns\\keql\\Images\\minimize_down")
	keql.AchievmentFrameTrackerMinimizeButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
	keql.AchievmentFrameTrackerMinimizeButton:SetWidth(18)
	keql.AchievmentFrameTrackerMinimizeButton:SetHeight(18)
	keql.AchievmentFrameTrackerMinimizeButton:Show()
	keql.AchievmentFrameTrackerMinimizeButton:ClearAllPoints()
	keql.AchievmentFrameTrackerMinimizeButton:SetPoint("TOPRIGHT",AchievmentFrameTrackerTitle, "TOPRIGHT", -4,2)

	keql.AchievmentFrameTrackerMinimizeButton:SetScript("OnClick", function() 
		keql:ToggleTracker()  
	end)

	keql:CreateOptionsAchiev()
end

function keql:CreateOptionsAchiev()
	optionsmain.args.general.args.EnableATracker = {
					type = 'toggle',
					order = 5,
					width = 'full',
					name = "Enable Achievementtracker",
					desc = L["Make the Tracker movable even with CTMod loaded. Please check your CTMod config before using it"],
					get = function(info) return keql.db.profile.ATrackerEnable end,
					set = function(info, newval)
						self.db.profile.ATrackerEnable = newval
						if newval then
							keql:InitAchievementTracker()
						end
					end,
		}


end


function keql:ToggleTracker ()
	if keql.db.profile.ATrackerToggled then 
		keql.AchievmentFrameTracker:SetHeight(100)
		AchievementWatchFrame:Show()
		keql.db.profile.ATrackerToggled = false
	else
		keql.AchievmentFrameTracker:SetHeight(32)
		AchievementWatchFrame:Hide()
		keql.db.profile.ATrackerToggled = true
	end
	
	AchievementWatchFrame:SetParent("AchievmentFrameTracker")
	--AchievementWatchFrame:ClearAllPoints()
	--AchievementWatchFrame:SetPoint("TOPLEFT",AchievmentFrameTracker, "TOPLEFT", 0,-32)
	AchievementWatchFrame:SetMovable(true)
	AchievementWatchFrame:EnableMouse(true)
	AchievementWatchFrame:SetScript("OnDragStart",
        function() 
          keql.AchievmentFrameTracker.ismoving = true 
          keql.AchievmentFrameTracker:StartMoving() 
        end)
	AchievementWatchFrame:SetScript("OnDragStop",
        function() 
          keql.AchievmentFrameTracker.ismoving = false 
          keql.AchievmentFrameTracker:StopMovingOrSizing() 
          --keql:SavePositionTracker() 
        end)
	
end

function keql:AchievementFrameManagePosition()
	if not AchievementWatchFrame:IsShown() then
		-- Frame not shown, do nothing
		return
	end
	AWFW = AchievementWatchFrame.desiredWidth
	AchievementWatchFrame:ClearAllPoints()
	if keql.db.profile.ATrackerEnable and keql.AchievmentFrameTracker then
		AchievementWatchFrame:SetPoint("TOPLEFT", "AchievmentFrameTracker", "TOPLEFT", 13, -32)
		keql.AchievmentFrameTracker:SetWidth(AWFW + 26)
		keql.AchievmentFrameTracker:SetHeight(AchievementWatchFrame:GetHeight() + 58)
		AchievementWatchFrame:SetBackdrop({	bgFile="Interface\\Tooltips\\UI-Tooltip-Background",})
	else
		AchievementWatchFrame:SetPoint("TOPRIGHT", "MinimapCluster", "BOTTOMRIGHT", -93, -13)
	end
	if AWFW then
		AchievementWatchFrame:SetWidth(AWFW);
	end
	
		
	
end		



function keql:printpoints()
	for i = 0, QuestWatchFrame:GetNumPoints() do
		point, relativeTo, relativePoint, xOfs, yOfs = AchievementWatchFrame:GetPoint(i)
		DEFAULT_CHAT_FRAME:AddMessage(point)
		DEFAULT_CHAT_FRAME:AddMessage(relativeTo:GetName())
		DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		DEFAULT_CHAT_FRAME:AddMessage(yOfs)
	end
	
end

function keql:printlines()
	print("---- Lines ----")
	for i = 1, 20 do
		line = getglobal("AchievementWatchLine" .. i)
		if line and line:IsShown() then 
			print("- Line " .. i ..": " .. line:GetWidth())
			--print(line:GetText())
		end
		line = getglobal("AchievementWatchLine" .. i .. "Button")
		if line and line:IsShown() then 
			print("- Button " .. i ..": " .. line:GetWidth())
			--print(line:GetText())
		end
		line = getglobal("AchievementWatchLine" .. i .. "StatusBar")
		if line and line:IsShown() then 
			print("- StatusBar " .. i ..": " .. line:GetWidth())
			--print(line:GetText())
		end
	end
end

--- EOF ---