local keql = LibStub("AceAddon-3.0"):GetAddon("keql")
local addon = keql
local Quixote = LibStub("LibQuixote-2.0")
local db, dbpc
local L = LibStub("AceLocale-3.0"):GetLocale("keql")
local addtags = false

function keql:InitQuestLog()
	db, dbpc = keql.db.profile, keql.dbpc.profile
	self:RegisterEvent("QUEST_PROGRESS")
	self:RegisterEvent("QUEST_COMPLETE")
    --self:RegisterEvent("QUEST_LOG_UPDATE")
	Quixote.RegisterCallback(self, "Update", "Quixote_Update")
	Quixote.RegisterCallback(self, "Quest_Complete", "Quixote_Quest_Complete")
	Quixote.RegisterCallback(self, "Quest_Gained", "Quixote_Quest_Gained")
	Quixote.RegisterCallback(self, "Objective_Update", "Quixote_Objective_Update")
    --self:RegisterEvent("Quixote_Leaderboard_Update")
    
	self:Hook("QuestLog_OnShow", "Hooks_QuestLog_OnShow", true)	    
    self:RawHook("QuestLogTitleButton_OnClick",true)
    self:RawHook("GetQuestLogTitle", true)
    --self:Hook("QuestLogCollapseAllButton_OnClick","Hooks_QuestLogCollapseAllButton_OnClick", true)
    self:RawHook("QuestLog_Update", true)

	QuestLogTitleText:SetText(L["Bear's Extended Quest Log"])

	QuestLogFrame:SetScript("OnDragStart",function() QuestLogFrame:StartMoving() end)
	QuestLogFrame:SetScript("OnDragStop",function() QuestLogFrame:StopMovingOrSizing() keql:SavePosition() end)
	QuestLogFrame:SetAlpha(db.questlog.alpha)
	QuestLogFrame:SetScale(db.questlog.scale)
	keql:SetQuestLogFontSize(db.questlog.fontsize)
	keql:ExtendedQuestLog()
end

function keql:ExtendedQuestLog()
		
		-- Code from DoubleWide by Iriel
		-- {
		QuestLogFrame:SetAttribute("UIPanelLayout-width", 680)
		QuestLogFrame:SetWidth(718)
		QuestLogFrame:SetHeight(561)
		QuestLogDetailScrollFrame:ClearAllPoints()
		QuestLogDetailScrollFrame:SetPoint("TOPLEFT", QuestLogListScrollFrame, "TOPRIGHT", 34, 0)
		QuestLogDetailScrollFrame:SetHeight(410)
		QuestLogListScrollFrame:SetHeight(410)

		local oldQuestsDisplayed = QUESTS_DISPLAYED
		QUESTS_DISPLAYED = 27
		for i = oldQuestsDisplayed + 1, QUESTS_DISPLAYED do
			local button = CreateFrame("Button", "QuestLogTitle" .. i, QuestLogFrame,"QuestLogTitleButtonTemplate")
			button:SetID(i)
			button:Hide()
			button:ClearAllPoints()
			button:SetPoint("TOPLEFT", getglobal("QuestLogTitle" .. (i-1)), "BOTTOMLEFT", 0, 1)
		end

		local regions = { QuestLogFrame:GetRegions() }

		local xOffsets = { Left = 3; Middle = 259; Right = 515; }
		local yOffsets =  { Top = 0; Bot = -256; }

		local textures = {
			TopLeft = "Interface\\AddOns\\keql\\Images\\topleft",
			TopMiddle = "Interface\\AddOns\\keql\\Images\\topmid_on",
			TopRight = "Interface\\AddOns\\keql\\Images\\topright",

			BotLeft = "Interface\\AddOns\\keql\\Images\\botleft",
			BotMiddle = "Interface\\AddOns\\keql\\Images\\botmid_on",
			BotRight = "Interface\\AddOns\\keql\\Images\\botright",
		
		}

		local PATTERN = "^Interface\\QuestFrame\\UI%-QuestLog%-(([A-Z][a-z]+)([A-Z][a-z]+))$"
		for _, region in ipairs(regions) do
			if region:IsObjectType("Texture") then
				local texturefile = region:GetTexture()
				if texturefile == "Interface\\QuestFrame\\UI-QuestLog-BookIcon" then
					region:SetTexture("Interface\\Addons\\keql\\Images\\icon")
				end
				local which, yofs, xofs = texturefile:match(PATTERN)
				xofs = xofs and xOffsets[xofs]
				yofs = yofs and yOffsets[yofs]
				if xofs and yofs and textures[which] then
					region:ClearAllPoints()
					region:SetPoint("TOPLEFT", QuestLogFrame, "TOPLEFT", xofs, yofs)
					region:SetTexture(textures[which])
					region:SetWidth(256)
					region:SetHeight(256)
					textures[which] = nil
				end
			end
		end

		for name, path in pairs(textures) do
			local yofs, xofs = name:match("^([A-Z][a-z]+)([A-Z][a-z]+)$")
			xofs = xofs and xOffsets[xofs]
			yofs = yofs and yOffsets[yofs]
			if xofs and yofs then
				local region = QuestLogFrame:CreateTexture(nil, "ARTWORK")
				region:ClearAllPoints()
				region:SetPoint("TOPLEFT", QuestLogFrame, "TOPLEFT", xofs, yofs)
				region:SetWidth(256)
				region:SetHeight(256)
				region:SetTexture(path)
			end
		end
		-- }
		-- Code from DoubleWide by Iriel

		keql.MinimizeButton = CreateFrame("Button","MinimizeButton", QuestLogFrame, "UIPanelButtonTemplate")
		keql.MinimizeButton:SetNormalTexture("Interface\\AddOns\\keql\\Images\\minimize_up")
		keql.MinimizeButton:SetPushedTexture("Interface\\AddOns\\keql\\Images\\minimize_down")
		keql.MinimizeButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
		keql.MinimizeButton:SetWidth(24)
		keql.MinimizeButton:SetHeight(24)
		keql.MinimizeButton:Show()
		keql.MinimizeButton:ClearAllPoints()
		keql.MinimizeButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT", 0,5)
		keql.MinimizeButton:SetScript("OnClick", function() 
			if dbpc.minimized then 
				keql:Maximize() 
			else 
				keql:Minimize() 
			end 
		end)
	
	--end 
end

function keql:Minimize()
	dbpc.minimized = true 
	keql.MinimizeButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT", 3,5)		
	keql.MinimizeButton:SetNormalTexture("Interface\\AddOns\\keql\\Images\\restore_up")
	keql.MinimizeButton:SetPushedTexture("Interface\\AddOns\\keql\\Images\\restore_down")
	QuestLogDetailScrollFrame:Hide()
	QuestLogFrame:SetAttribute("UIPanelLayout-width", 390)
	QuestLogFrame:SetWidth(387)
	local regions = { QuestLogFrame:GetRegions() }	
	for _, region in ipairs(regions) do
		if region:IsObjectType("Texture") then
			local texturefile = region:GetTexture()
			if texturefile == "Interface\\AddOns\\keql\\Images\\topmid_on" then
				region:SetTexture("Interface\\AddOns\\keql\\Images\\topmid_off")
			end
			if texturefile == "Interface\\AddOns\\keql\\Images\\botmid_on" then
				region:SetTexture("Interface\\AddOns\\keql\\Images\\botmid_off")
			end			
			if texturefile == "Interface\\AddOns\\keql\\Images\\botright" then
				region:SetTexture("Interface\\AddOns\\keql\\Images\\botright_off")
			end	
			if texturefile == "Interface\\AddOns\\keql\\Images\\topright" then
				region:SetTexture("Interface\\AddOns\\keql\\Images\\topright_off")
			end				
		end
	end	
end

function keql:Maximize()
	dbpc.minimized = false 
	local numEntries, _ = GetNumQuestLogEntries()
	if ( numEntries == 0 ) then
		return	
	end	
	keql.MinimizeButton:SetPoint("RIGHT",QuestLogFrameCloseButton, "LEFT", 0,5)	
	keql.MinimizeButton:SetNormalTexture("Interface\\AddOns\\keql\\Images\\minimize_up")
	keql.MinimizeButton:SetPushedTexture("Interface\\AddOns\\keql\\Images\\minimize_down")
	QuestLogDetailScrollFrame:Show()
	QuestLogFrame:SetAttribute("UIPanelLayout-width", 680)
	QuestLogFrame:SetWidth(718)

	local regions = { QuestLogFrame:GetRegions() }		
	for _, region in ipairs(regions) do
		if region:IsObjectType("Texture") then
			local texturefile = region:GetTexture()
			if texturefile == "Interface\\AddOns\\keql\\Images\\topmid_off" then
				region:SetTexture("Interface\\AddOns\\keql\\Images\\topmid_on")
			end
			if texturefile == "Interface\\AddOns\\keql\\Images\\botmid_off" then
				region:SetTexture("Interface\\AddOns\\keql\\Images\\botmid_on")
			end			
			if texturefile == "Interface\\AddOns\\keql\\Images\\botright_off" then
				region:SetTexture("Interface\\AddOns\\keql\\Images\\botright")
			end	
			if texturefile == "Interface\\AddOns\\keql\\Images\\topright_off" then
				region:SetTexture("Interface\\AddOns\\keql\\Images\\topright")
			end				
		end
	end		
end

function keql:SavePosition()
	local Left = QuestLogFrame:GetLeft()
	local Top = QuestLogFrame:GetTop()
	if Left and Top then
		dbpc.qlogposx = Left
		dbpc.qlogposy = Top
	end
end

--
-- EVENTS --
--
function keql:QUEST_PROGRESS()
	if db.questlog.autocomplete then
		CompleteQuest()
	end
end

function keql:QUEST_COMPLETE()
	if db.questlog.autocomplete and GetNumQuestChoices() == 0 then
		GetQuestReward(QuestFrameRewardPanel.itemChoice)
	end	
end

function keql:Quixote_Quest_Complete(questname, uid)
	if db.questlog.completedisplay then
		UIErrorsFrame:AddMessage(questname.." "..L["Completed!"], 1.0, 0.8, 0.0, 1.0, UIERRORS_HOLD_TIME)
		if db.InfoSound and db.InfoSound ~= "" then 
			PlaySoundFile(db.InfoSound)
		end
	end
	if db.tracker.removecompleted then
		Quixote:RemoveQuestWatchByUid(uid)
	end
end

function keql:Quixote_Quest_Gained(questname, uid)
	if db.tracker.addnewquests then
		self:Debug("Quixote_Quest_Gained: uid:"..tostring(uid))
		Quixote:AddQuestWatchByUid(uid)
	end
end

function keql:Quixote_Objective_Update(questname, uid, description, numHad, numGot, numNeeded, type)
	if db.questlog.announce and GetNumPartyMembers() > 0 then
		local chatType = "PARTY"	
		local text = ""
		local objText = ""
		local qstatus
		if type == "item" or type == "monster" or type == "reputation" then
			objText = objText..": "..numGot.."/"..numNeeded
		end		
		text = description..objText
		SendChatMessage(text, chatType)
		_,_,_,_,_,_,qstatus = Quixote:GetQuestByUid(uid)
		if numGot == numNeeded and (qstatus == 1) then
			SendChatMessage(questname.." "..L["Completed!"], chatType)
		end		
	end
	if AUTO_QUEST_WATCH=="0" and db.tracker.addobjectiveupdate then
		Quixote:AddQuestWatchByUid(uid)
	end
end

function keql:Quixote_Update()
	addon:launcherUpdate()
	-- Workaround for a quixote issue
	--keqlQ:QUEST_LOG_UPDATE()
end

function keql:QuestLogTitleButton_OnClick(self, button)
	if dbpc.minimized then
		keql:Maximize()
	end
	local questName = this:GetText()
	local questIndex = this:GetID() + FauxScrollFrame_GetOffset(QuestLogListScrollFrame)	
	
	--[[if not IsShiftKeyDown() and IsControlKeyDown()  then
		if ChatFrameEditBox:IsVisible() then
			keql:AddQuestStatusToChatFrame(questIndex)
		end			
	end]]
	if  IsShiftKeyDown()  then
		local questLogTitleText, isHeader, isCollapsed, firstTrackable, lastTrackable, numTracked, numUntracked
		lastTrackable = -1
		numTracked = 0
		numUntracked = 0
		local track = false
		if  this.isHeader  then
			for i=1, GetNumQuestLogEntries(), 1 do
				questLogTitleText, _, _, _, isHeader, isCollapsed = GetQuestLogTitle(i)
				if  questLogTitleText == questName  then
					track = true
					firstTrackable = i+1
				elseif ( track ) then
					if  not isHeader  then
						if IsQuestWatched(i)  then
							numTracked = numTracked+1
							RemoveQuestWatch(i)
						else
							numUntracked = numUntracked+1
							RemoveQuestWatch(i)
						end
					end
					if  isHeader and questLogTitleText ~= questName  then
						lastTrackable = i-1
						break
					end
				end
			end
			if  lastTrackable == -1  then
				lastTrackable = GetNumQuestLogEntries()
			end
			if  numUntracked == 0  then
				-- Untrack all
				for i=firstTrackable, lastTrackable, 1 do
					RemoveQuestWatch(i)
				end
				QuestWatch_Update()
			else
				-- Track all
				for i=firstTrackable, lastTrackable, 1 do
					--if GetNumQuestLeaderBoards(i) > 0 then
						-- Set an error message if trying to show too many quests
						if ( GetNumQuestWatches() > MAX_WATCHABLE_QUESTS ) then
							UIErrorsFrame:AddMessage(format(QUEST_WATCH_TOO_MANY, MAX_WATCHABLE_QUESTS), 1.0, 0.1, 0.1, 1.0)
							break
						end
						AddQuestWatch(i)
					--end
				end
				QuestWatch_Update()
			end
			QuestLog_Update()
		end
		if ( ChatFrameEditBox:IsVisible() ) then
			--ChatFrameEditBox:Insert(strsub(strtrim(this:GetText()),11))
			local questLink = GetQuestLink(questIndex);
			if ( questLink ) then
				ChatEdit_InsertLink(questLink);
			else
				ChatFrameEditBox:Insert(gsub(this:GetText(), " *(.*)", "%1"))
			end
		else
			_, _, _, _, isHeader, isCollapsed = GetQuestLogTitle(questIndex)
			-- Shift-click toggles quest-watch on this quest.
			if not isHeader then
				if ( IsQuestWatched(questIndex) ) then
					RemoveQuestWatch(questIndex)
					QuestWatch_Update()
				else
					--if GetNumQuestLeaderBoards(questIndex) > 0 then
						-- Set an error message if trying to show too many quests
						if ( GetNumQuestWatches() >= MAX_WATCHABLE_QUESTS ) then
							UIErrorsFrame:AddMessage(format(QUEST_WATCH_TOO_MANY, MAX_WATCHABLE_QUESTS), 1.0, 0.1, 0.1, 1.0)
							return
						end
						AddQuestWatch(questIndex)
						QuestLog_Update()
						QuestWatch_Update()
					--end
				end
			end
		end
	end
	_, _, _, _, isHeader, isCollapsed = GetQuestLogTitle(questIndex)
	if (not IsShiftKeyDown() and isHeader) or not isHeader then
		QuestLog_SetSelection(questIndex)
	end
	QuestLog_Update()
end

function keql:Hooks_QuestLog_OnShow()
	--securecall(self.hooks.QuestLog_OnShow)
	
	if dbpc.qlogposx and dbpc.qlogposy then
		QuestLogFrame:ClearAllPoints()
		QuestLogFrame:SetPoint("TOPLEFT","UIParent", "BOTTOMLEFT", dbpc.qlogposx, dbpc.qlogposy)
	end
		
	if dbpc.minimized then
		keql:Minimize()
	end
	if db.questlog.alwaysminimize then
		keql:Minimize()
	end
	if db.questlog.alwaysmaximize then
		keql:Maximize()
	end
end

function keql:GetQuestLogTitle(...)
	local questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily = self.hooks["GetQuestLogTitle"](...)
	
	if db.questlog.showlevels and questLogTitleText and level and level > 0 and not isHeader and addtags then
		questLogTitleText = "[" .. level .. self:GetQuestTag(questTag, isDaily, suggestedGroup) .."] " .. questLogTitleText
		--self:Debug("hooked GetQuestLogTitle with tags")
	end
	--self:Debug(questLogTitleText)
	return questLogTitleText, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily
end

function addon:GetQuestTag(questTag, isDaily, suggestedGroup)
	local tag = ""
	if  questTag == GROUP then
		if suggestedGroup > 0 then
			tag = tag .. "G" .. suggestedGroup
		else
			tag = tag .. "G"
		end
	end
	if  questTag == ELITE  then
		tag = tag .. "+"
	end
	if  questTag == DUNGEON_DIFFICULTY2 then
		tag = tag .. "H"
	end
	if  questTag == RAID  then
		tag = tag .. "R"
	end
	if  questTag == PVP  then
		tag = tag .. "P"
	end
	if  questTag == LFG_TYPE_DUNGEON  then
		tag = tag .. "D"
	end
	if isDaily then
		tag = tag .. "Y"
	end
	return tag
end

function keql:Hooks_QuestLogCollapseAllButton_OnClick(this)
	self.hooks.QuestLogCollapseAllButton_OnClick(this)
	if dbpc.minimized then
		keql:Minimize()
	else
		keql:Maximize()
	end
end

function keql:QuestLog_Update()
	addtags = true
	securecall(self.hooks.QuestLog_Update)
	addtags = false
	local numEntries, numQuests = GetNumQuestLogEntries()
	if ( numEntries == 0 ) then
		keql:Minimize()	
	end
	if dbpc.minimized then
		keql:Minimize()
	else
		keql:Maximize()
	end
end

function keql:SetQuestLogFontSize(size)
	if not size or size == 0 then size = 12 end
	local font, fontsize, fontflags, button, buttontag
	for i = 1, QUESTS_DISPLAYED do
			buttontag = getglobal("QuestLogTitle"..i.."Tag")
			font,fontsize,fontflags = buttontag:GetFont()
			buttontag:SetFont(font,size)

            button = getglobal("QuestLogTitle"..i.."NormalText");
			font,fontsize,fontflags = button:GetFont()
            button:SetFont(font,size) 
	end

	font,fontsize,fontflags = QuestLogDummyText:GetFont()
	QuestLogDummyText:SetFont(font,size + 6)
	

-- Questdiscrition short
	-- title
	font,fontsize,fontflags = QuestLogQuestTitle:GetFont()
	QuestLogQuestTitle:SetFont(font,size + 6)

	-- description
	font,fontsize,fontflags = QuestLogObjectivesText:GetFont()
	QuestLogObjectivesText:SetFont(font,size)

    -- objetives
	for i = 1, 10 do
        buttontag = getglobal("QuestLogObjective" .. i);
        font,fontsize,fontflags = buttontag:GetFont()
		buttontag:SetFont(font,size)
	end   
	
	-- need money
	font,fontsize,fontflags = QuestLogRequiredMoneyText:GetFont()
	QuestLogRequiredMoneyText:SetFont(font,size)
	
-- Questdiscrition long
	-- title
    font,fontsize,fontflags = QuestLogDescriptionTitle:GetFont()
	QuestLogDescriptionTitle:SetFont(font,size + 6)
	
	-- description
    font,fontsize,fontflags = QuestLogQuestDescription:GetFont()
	QuestLogQuestDescription:SetFont(font,size)
	
--  Questreward
	-- title
	font,fontsize,fontflags = QuestLogRewardTitleText:GetFont()
	QuestLogRewardTitleText:SetFont(font,size+6)
	
	-- items
    font,fontsize,fontflags = QuestLogItemChooseText:GetFont()
	QuestLogItemChooseText:SetFont(font,size)

    -- items
    font,fontsize,fontflags = QuestLogItemReceiveText:GetFont()
	QuestLogItemReceiveText:SetFont(font,size)

    -- spell 
    font,fontsize,fontflags = QuestLogSpellLearnText:GetFont()
	QuestLogSpellLearnText:SetFont(font,size)

    -- titles
    font,fontsize,fontflags = QuestLogPlayerTitleText:GetFont()
	QuestLogPlayerTitleText:SetFont(font,size)
 
end

--- EOF ---
